
#ifndef __ARM9_H__
#define __ARM9_H__

/*
 * PSR MODE Bit Values
 */
#define USR32MOD	0x10
#define FIQ32MOD	0x11
#define IRQ32MOD	0x12
#define SVC32MOD	0x13
#define ABT32MOD	0x17
#define UDF32MOD	0x1b
#define SYS32MOD	0x1f

#define NOINT		0xc0
#define NOIRQ		0x80
#define NOFIQ		0x40

#endif
