
#include <asm_s3c2440.h>
#include <config.h>	

.global _run_higher_prior_order_task
.global _get_current_cpsr
.global _get_current_spsr
.global _get_current_sp	
	
_run_higher_prior_order_task:
	/*
	 * void _run_max_prior_task()
	 */
	ldr	sp, =curr_task
	ldr	sp, [sp]
#if 0
	add	sp, sp, #TASK_CONTEXT_FRAME	@ get task's spsr in struct tcb
	sub	sp, sp, #4
	ldr	r0, [sp]
	msr	spsr_cxsf, r0

	ldr	sp, =curr_task
	ldr	sp, [sp]

	ldmia	sp, {r0-r12, r13, r14}^	@ load r0-r12, r13_user, r14_usr
	add	sp, sp, #60		@ load user task's pc
	
	ldmia	sp!, {pc}^		@ load spsr, pc_usr
#else

	add	sp, sp, #8

	ldmdb	sp, {r0, lr}		@ load spsr, pc
	msr	spsr, r0

	ldmia	sp, {r0-r12, r13, r14}^	@ load r0-r12, sp_usr, lr_usr
	movs	pc, lr			@ return user_task

#endif