
#include <blue_kernel.h>
#include <tcb.h>

extern tcb_t *curr_task;
extern task_list_t task_ready_list;

void schedule()
{

	/*
	 * need_scheded -> 1
	 *  - time_slice   ؼ schedule ʿ 
	 *  
	 * need_scheded -> 2
	 *  - curr_task 켱  READY  task ־ schedule ʿ 
	 *
	 * etc
	 *  -  schedule Լ ȣ  (...)
	 */
	curr_task->task_stat = READY;
	if( curr_task->need_scheded == 1 )
	{
		curr_task->need_scheded	= 0;
		task_list_add(&task_ready_list, curr_task, TRUE);
	}
	else if( curr_task->need_scheded == 2 )
	{
		curr_task->need_scheded	= 0;
		task_list_add(&task_ready_list, curr_task, FALSE);
	}
	curr_task = task_list_get_first_node(&task_ready_list);

	if( curr_task == NULL )
		while(1)
			kernel_panic();
}
