
#include <blue_kernel.h>

unsigned int get_pc(void)
{
	
	unsigned int temp;
	__asm__ __volatile__("mov %0, pc\n"
			     :"=r" (temp)
			     :
			     :"memory");

	return temp;
}

unsigned int get_sp(void)
{

	unsigned int temp;
	__asm__ __volatile__("mov %0, sp\n"
			     :"=r" (temp)
			     :
			     :"memory");

	return temp;
}

unsigned int get_cpsr(void)
{

	unsigned int temp;
	__asm__ __volatile__("mrs %0, cpsr\n"
			     :"=r" (temp)
			     :
			     :"memory");

	return temp;
}

unsigned int get_spsr(void)
{

	unsigned int temp;
	__asm__ __volatile__("mrs %0, spsr\n"
			     :"=r" (temp)
			     :
			     :"memory");

	return temp;
}
